unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ActnList,
  Buttons, ExtCtrls, Spin, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    ComboBox1: TComboBox;
    ListBox1: TListBox;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure SpinEdit1Change(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  strList : TStringList;

implementation

{$R *.lfm}

function GetTextHeight(AFont: TFont): Integer;
var
  bmp: TBitmap;
  tm: TLCLTextMetric;
begin
  bmp := TBitmap.Create;
  try
    bmp.SetSize(1, 1);
    bmp.Canvas.Font.Assign(AFont);
    bmp.Canvas.GetTextMetrics(tm);
    Result := abs(tm.Height);
  finally
    bmp.Free;
  end;
end;

{ TForm1 }


procedure TForm1.Button1Click(Sender: TObject);
begin
  Listbox1.Items.LoadFromFile('filesystems.txt');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Listbox1.Items.LoadFromFile('dmesg.txt');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Listbox1.Items.LoadFromFile('lscpu.txt');
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Listbox1.Items.LoadFromFile('PCI.txt');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   Listbox1.Items.LoadFromFile('SCSI.txt');
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  showmessage('Why Not ;-)');
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Listbox1.Items.LoadFromFile('usb.txt');
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
begin
  // Make the listbox sse the font selected in the combobox
  Listbox1.Font.Name := Combobox1.Items[Combobox1.ItemIndex];
  // Recalculate the line height because it depends on the font
  Listbox1.ItemHeight := GetTextHeight(Listbox1.Font);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Read the available fonts into the combobox...
  Combobox1.Items.Assign(Screen.Fonts);
  // ... and select in the combobox the currently selected listbox font.
  Combobox1.ItemIndex := Combobox1.Items.IndexOf(Listbox1.Font.Name);
  // Set the spinedit to the current font size of the list box
  SpinEdit1.Value := Listbox1.Font.Size;

  // Switch the listbox to owner-draw mode with the same row heights for all
  // items ("fixed")
  Listbox1.Style := lbOwnerDrawFixed;
  // Calculated the minimum line height from the font metric
  Listbox1.ItemHeight := GetTextHeight(Listbox1.Font);
  // Install the OnDrawItem handler required when an owner-draw style is selected.
  Listbox1.OnDrawItem := @Listbox1DrawItem;
end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  ARect: TRect; State: TOwnerDrawState);
begin
  // Draw the background; color has already been set.
  Listbox1.Canvas.FillRect(ARect);
  // Draw the text
  Listbox1.Canvas.TextOut(ARect.Left, ARect.Top, Listbox1.Items[Index]);
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  // Make the listbox use the font size selected in the spin edit
  Listbox1.Font.Size := SpinEdit1.Value;
  // Recalculate the line height because it depends on the font size
  Listbox1.ItemHeight := GetTextHeight(Listbox1.Font);
end;

end.


